# ../scripts/custom/gg_knifenade/modules/sparks.py

# =============================================================================
# >> IMPORTS
# =============================================================================
# EventScripts Imports
#   ES
from es import entitysetvalue
from es import InsertServerCommand

# SPE Imports
from spe import getIndexOfEntity
from spe import removeEntityByInstance


# =============================================================================
# >> CLASSES
# =============================================================================
class _SparksPlayers(dict):
    '''Class used to store players and their sparks entity'''

    def __setitem__(self, userid, entity):
        '''Method used to add a player to the dictionary'''

        # Typecast the given userid
        userid = int(userid)

        # Is the userid already in the dictionary?
        if userid in self:

            # If so, return
            return

        # Get the given entity's index
        index = getIndexOfEntity(entity)

        # Set the entity's targetname
        entitysetvalue(index, 'targetname', entity)

        # Give the player sparks
        InsertServerCommand(
            'es_xfire %s %s SetParent !activator;' % (userid, entity) +
            'es_xfire %s %s AddOutput "spawnflags 896";' % (userid, entity) +
            'es_xfire %s %s AddOutput "angles -90 0 0";' % (userid, entity) +
            'es_xfire %s %s AddOutput "magnitude 8";' % (userid, entity) +
            'es_xfire %s %s AddOutput "traillength 3";' % (userid, entity) +
            'es_xfire %s %s StartSpark' % (userid, entity))

        # Add the player to the dictionary
        super(_SparksPlayers, self).__setitem__(userid, entity)

    def __delitem__(self, userid):
        '''Method used to remove the given userid from the dictionary'''

        # Typecast the given userid
        userid = int(userid)

        # Is the userid in the dictionary?
        if not userid in self:

            # If not, no need to remove them
            return

        # Get the player's sparks entity
        entity = self[userid]

        # Turn the sparks off
        InsertServerCommand('es_xfire %s %s StopSpark' % (userid, entity))

        # Remove the sparks
        removeEntityByInstance(entity)

        # Remove the player from the dictionary
        super(_SparksPlayers, self).__delitem__(userid)

# Get the _SparksPlayers instance
sparks = _SparksPlayers()
